/*  hybrid.c
 *	
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
*/

#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <asm/types.h>
#include <sys/ioctl.h>
#include "videodev2.h"

int main()
{
        int fd,i;
        int input=0;
        v4l2_std_id id=V4L2_STD_PAL_B;
        struct v4l2_frequency vf;

        vf.tuner = 0;
//        vf.frequency = 313250*2*1000/125 ; // 313250 is frequency 
        vf.frequency = 147250*2*1000/125 ; // 147250 is frequency 
        vf.type = V4L2_TUNER_ANALOG_TV;

	for(i=0;i<3;i++)
	{
		printf("=============================================\n");
		printf("Call xine to watch Digital TV                \n");	
		printf("  NOTE:                                      \n");
		printf("     1.To watch a DVB-T program, just press  \n"); 
		printf("       the \"DVB\" button on the GUI window. \n");
		printf("     2.Please Be sure that the signal is     \n");
		printf("       changed to Digital TV.                \n");
		printf("=============================================\n");
		printf("Press Enter key to continue...\n");
		system("read pause");
		printf("Press Ctrl-C to stop watching Digital TV\n\n");

        	fd = open("/dev/video1", O_RDONLY); //for power management issue
		system("xine");

        	printf("=============================================\n");
	        printf("Closing digital TV...                        \n");
        	printf("=============================================\n");		
		sleep(5); // maybe 3 second is enough
        	close(fd);

	        printf("=============================================\n");
        	printf("Call xtv & audio_player to watch Analog TV   \n");
                printf("  NOTE:                                      \n");
                printf("     1.Please Be sure that the signal is     \n");
                printf("       changed to Analog TV.                 \n");
	        printf("=============================================\n");
                printf("Press Enter key to continue...\n");
                system("read pause");
		printf("Press Ctrl-C to stop watching Analog TV\n\n");

		fd = open("/dev/video0", O_RDWR); //for power management issue

		ioctl(fd, VIDIOC_S_INPUT, &input); // set input
		printf("Set Input\t: Tuner\n");
		ioctl(fd, VIDIOC_S_STD, &id); // set standard
		printf("Set Standard\t: PAL_B\n");
		ioctl(fd, VIDIOC_S_FREQUENCY, &vf); //set channel
		printf("Set Frequency\t: 147.25MHZ\n");
		close(fd);

		system("(./audio_player > /dev/null)&");
		system("./xtv");
		system("touch /dev/video2");
	}

	return 1;
}
